/**
 * 
 */
import java.io.*;



/**
 * @author verel
 *
 */
public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Automata automate = new Automata(21);

		String bestName = "solution_19a.dat";

		// read a rule from file
		int [] rules = initRulesFromFile(bestName);

		// compute the fitness
		int fit = automate.f(rules, 21);

		// print the fitness on the output
		System.out.println(fit);
	}

	public static void printToFile(int fitness, int [] rules, PrintWriter ecrivain) {
		ecrivain.print(fitness);
		for(int i = 0; i < 216; i++) {
			ecrivain.print(" ");
			ecrivain.print(rules[i]);
		}
		ecrivain.println();
	}

	public static int [] initRulesFromFile(String fileName) {
		// 5 tats + l'tat "bord"
		int n = 5 + 1;

		int [] rules = new int[n * n * n];

		try {
			FileReader fichier = new FileReader(fileName);

			StreamTokenizer entree = new StreamTokenizer(fichier);

			int i = 0;
			while(entree.nextToken() == StreamTokenizer.TT_NUMBER)
			{		
				rules[i] = (int)entree.nval;
				i++;
			} 
			fichier.close();
		}		
		catch (Exception e){
			System.out.println(e.toString());
		}

		return rules;
	}



}
