/**
 * 
 */
import java.io.*;



/**
 * @author verel
 *
 */
public class Test_init {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Automata automate = new Automata(21);

		int [] rules = new int[216];

		String outName = "/Users/verel/enseignement/12-13/EA/TP/code/out.dat";

		Initialization init = new Initialization();

		PrintWriter ecrivain;
		try {
			ecrivain =  new PrintWriter(new BufferedWriter(new FileWriter(outName)));

			// initialization using the class Initialization
			init.init(rules);

			// compute the fitness
			fit = automate.f(rules, 21);

			// print into a file
			printToFile(fit, rules, ecrivain);


			ecrivain.close();
		}
		catch (Exception e){
			System.out.println(e.toString());
		}
		
		System.out.println("The End.");
	}

	public static void printToFile(int fitness, int [] rules, PrintWriter ecrivain) {
		ecrivain.print(fitness);
		for(int i = 0; i < 216; i++) {
			ecrivain.print(" ");
			ecrivain.print(rules[i]);
		}
		ecrivain.println();
	}

	public static int [] initRulesFromFile(String fileName) {
		// 5 tats + l'tat "bord"
		int n = 5 + 1;

		int [] rules = new int[n * n * n];

		try {
			FileReader fichier = new FileReader(fileName);

			StreamTokenizer entree = new StreamTokenizer(fichier);

			int i = 0;
			while(entree.nextToken() == StreamTokenizer.TT_NUMBER)
			{		
				rules[i] = (int)entree.nval;
				i++;
			} 
			fichier.close();
		}		
		catch (Exception e){
			System.out.println(e.toString());
		}

		return rules;
	}



}
