#ifndef initialisation_h
#define initialisation_h

#include <declaration.h>
#include <stdlib.h>
#include <automata.h>

void initialisation(Regle rules) {
  for(int i = 0; i < nbFree; i++)
    rules[ authorised[i] ] = rand() % FIRE;
  
  // les regles repos (obligatoires)
  setRule(rules, REPOS, REPOS, REPOS, REPOS);
  setRule(rules, BORD , REPOS, REPOS, REPOS);
  setRule(rules, REPOS, REPOS, BORD , REPOS);
  
  // les regles feu (tres conseilles)
  setRule(rules, GEN,  GEN, GEN,  FIRE);
  setRule(rules, BORD, GEN, GEN,  FIRE);
  setRule(rules, GEN,  GEN, BORD, FIRE);
  
  // pour réussir longueur 2
  setRule(rules, GEN,  REPOS, BORD,  GEN); 
  setRule(rules, BORD, GEN,   REPOS, GEN);
  
  // les regles a priori (signal de periode 2 vers la droite)
  setRule(rules, GEN, REPOS, REPOS, NONGEN);
  setRule(rules, NONGEN, REPOS, REPOS, GEN);
  
  // a priori bord droit
  setRule(rules, NONGEN, REPOS, BORD, NONGEN);
}
	
#endif
